#include "ai8051u.h"
#include "intrins.h"
#include "hard_i2c.h"

//sbit    SDA     =   P1^4;
//sbit    SCL     =   P1^5;


//void I2C_Isr() interrupt 24
//{
//    _push_(P_SW2);
//    P_SW2 |= 0x80;
//    if (I2CMSST & 0x40)
//    {
//        I2CMSST &= ~0x40;                       //жϱ־
//        i2c_busy = 0;
//    }
//    _pop_(P_SW2);
//}

void wait()
{
    while (!(I2CMSST & 0x40));
    I2CMSST &= ~0x40;
}

void I2C_start()
{

    I2CMSCR = 0x01;                             //START
    wait();
}

void I2C_recv_ack()
{

    I2CMSCR = 0x03;                             //ͶACK
    wait();
}

void I2C_send_byte(unsigned char dat)
{
    I2CTXD = dat;                               //дݵݻ
//    I2CMSCR = 0x02;                             //SEND
    wait();
}



//void I2C_qsend_byte(unsigned char dat)
//{
//    I2CTXD = dat;                               //дݵݻ
//    wait();
//}

unsigned char I2C_recv_byte()
{
    I2CMSCR = 0x04;                             //RECV
    wait();
    return I2CRXD;
}

void I2C_send_ack()
{
    I2CMSST = 0x00;                             //ACKź
    I2CMSCR = 0x05;                             //ACK
    wait();
}

void I2C_send_nack()
{
    I2CMSST = 0x01;                             //NAKź
    I2CMSCR = 0x05;                             //ACK
    wait();
}

void I2C_stop()
{
    I2CMSCR = 0x06;                             //STOP
    wait();
}

char I2C_send_bytes(unsigned char sla,unsigned char cb, unsigned char *pdat,unsigned int n){

    unsigned int i;
    I2C_start();
    I2C_send_byte(sla);   
    I2C_send_byte(cb);
    for(i = 0; i < n/16; i++)
    {
        I2C_send_byte(*pdat++); //0
        I2C_send_byte(*pdat++); //1
        I2C_send_byte(*pdat++); //2
        I2C_send_byte(*pdat++); //3
        I2C_send_byte(*pdat++); //4
        I2C_send_byte(*pdat++); //5
        I2C_send_byte(*pdat++); //6
        I2C_send_byte(*pdat++); //7
        I2C_send_byte(*pdat++); //8
        I2C_send_byte(*pdat++); //9
        I2C_send_byte(*pdat++); //10
        I2C_send_byte(*pdat++); //11
        I2C_send_byte(*pdat++); //12
        I2C_send_byte(*pdat++); //13
        I2C_send_byte(*pdat++); //14
        I2C_send_byte(*pdat++); //15
    }
    I2C_stop();
    return  0;
}

char I2C_recv_bytes(unsigned char sla,unsigned char cb, unsigned char *pdat,unsigned int n){
    unsigned char i;
    I2C_start();
    I2C_send_byte(sla);
//    if(ack == 0)    return -1;    
    I2C_send_byte(cb);
//    if(ack == 0)    return -1;
    for(i = 0; i < n; i++)
    {
        *pdat = I2C_recv_byte();
        pdat++;
    }
    I2C_recv_byte();
    I2C_send_nack();
    I2C_stop();
    return  0;
}

void I2C_Init(){
    P_SW2 = 0x80;
//    P_SW2 = (P_SW2 & ~0x30) | 0x10;		//I2C: I2CSCL(P1.5), I2CSDA(P1.4)

    I2CCFG = 0xE0;                              //ʹI2Cģʽ
    I2CMSAUX = 0x01;                            //ʹԶ͹
    I2CMSST = 0x00;
    EA = 1;
}
 

