#include <ai8051u.h>
#include <intrins.h>
#include "soft_i2c.h"


sbit SCL = P2^4;
sbit SDA = P2^3;
bit ack;        //Ӧ־ack = 1 Ӧack = 0 Ӧ


void delay1us()     //ϵͳƵ11.0592MHz
{
    unsigned char data i;
    i = 1;
	_nop_();
	_nop_();
	while (--i);
}

void delay5us()     //ϵͳƵ11.0592MHz
{    
    unsigned char data i;
    _nop_();
	i = 16;
	while (--i);
}

void I2C_start()    //I2Cʼź
{
    SDA = 1;
    delay1us();
    SCL = 1;
    delay5us();
    SDA = 0;
    delay5us();
    SCL = 0;
    delay5us();
}

void I2C_stop()     //I2Cֹͣź
{
    SDA = 0;
    delay1us();
    SCL = 1;
    delay5us();
    SDA = 1;
    delay5us();
    SCL = 0;
    delay5us();
}

void I2C_send_ack()      //I2CӦź
{
    SDA = 0;
    delay5us();
    SCL = 1;
    delay5us();
    SCL = 0;
    delay5us();
}

void I2C_send_nack()     //I2C߷Ӧź
{
    SDA = 1;
    delay5us();
    SCL = 1;
    delay5us();
    SCL = 0;
    delay5us();
}

void I2C_send_byte(unsigned char dat){
    unsigned char i;
    SCL = 0;
    for(i = 0; i < 8; i++)
    {
        SDA = (bit)((dat & 0x80) >> 7);
        dat <<= 1;
        SCL = 1;
        delay1us();
        SCL = 0;
        delay1us();
    }
    SDA = 1;
    delay1us();
    SCL = 1;
    delay1us();
    ack = ~SDA;     //ӦӦ־ack = 1Ӧack = 0
    SCL = 0;
    delay1us();
}
//========================================================================
// : char I2C_send_bytes()
// : ģI2Cӻnֽݡ
// ڲ: sla:ӻַcb֣pdatָ͵ݣnҪݵ
// : ɹ0ʧܷ-1.
// ע: 
//========================================================================
char I2C_send_bytes(unsigned char sla,unsigned char cb, unsigned char *pdat,unsigned int n){
    unsigned int i;
    I2C_start();
    I2C_send_byte(sla);
    if(ack == 0)    return -1;    
    I2C_send_byte(cb);
    if(ack == 0)    return -1;
    for(i = 0; i < n; i++)
    {
        I2C_send_byte(*pdat++);
        if(ack == 0)    return -1;
    }
    I2C_stop();
    return  0;
}

unsigned char I2C_recv_byte(){
    unsigned char recv_dat;
    unsigned char i;
    recv_dat = 0;
    SDA = 1;
    delay1us();
    for ( i = 0; i < 8; i++)
    {
        SCL = 0;
        delay5us();
        SCL = 1;
        recv_dat = (recv_dat << 1) | SDA ;
        delay5us();
    }
    SCL = 0;
    delay5us();
    return recv_dat;
}
//========================================================================
// : char I2C_recv_bytes()
// : ģI2CӴ豸ȡnֽݡ
// ڲ: sla:ӻַcb֣pdatָ͵ݣnҪݵ
// : ɹ0ʧܷ-1.
// ע: 
//========================================================================
char I2C_recv_bytes(unsigned char sla,unsigned char cb, unsigned char *pdat,unsigned int n){
    unsigned char i;
    I2C_start();
    I2C_send_byte(sla);
    if(ack == 0)    return -1;    
    I2C_send_byte(cb);
    if(ack == 0)    return -1;
    for(i = 0; i < n; i++)
    {
        *pdat = I2C_recv_byte();
        I2C_send_ack();
        pdat++;
    }
    I2C_recv_byte();
    I2C_send_nack();
    I2C_stop();
    return  0;
}

