#include "sys.h"
#include "oled.h"
#include "image.h"

sbit LED0 = P2^0;
sbit LED1 = P2^1;
unsigned long tick = 0;

char *USER_DEVICEDESC = NULL;
char *USER_PRODUCTDESC = NULL;
char *USER_STCISPCMD = "@STCISP#";

void delayms(int t)	//@11.0592MHz
{
	unsigned long edata i;
    while(--t){
        _nop_();
        _nop_();
        i = 2763UL;
        while (i) i--;
    }
}

void main(void)
{
    unsigned long pretime,curtime;
    unsigned int count;
    P_SW2 |= 0x80;		//B7λд1ʹܷXFR
    pretime = 0;
    curtime = 0;
    GPIO_Init();
    
    
    usb_init();                                     //USB CDC ӿ
    IE2 |= 0x80;                                    //ʹUSBж
    OLED_Init();
    delayms(200);
    OLED_Clear();
    OLED_ShowString(0,0,"ABCDEFGHIJKLMNOP");
    OLED_ShowString(0,2,"QRSTUVWXYZ");
    OLED_ShowString(0,4,"abcdefghijklmnop");
    OLED_ShowString(0,6,"qrstuvwxyz");
    delayms(2000);    
    OLED_Clear();
    Timer0_Init();
    EA = 1;											//IE |= 0X80;
	
	while (DeviceState != DEVSTATE_CONFIGURED);     //ȴUSB
	
	while(1)
	{
		
        if (bUsbOutReady)
        {
//            USB_SendData(UsbOutBuffer,OutNumber);   //ݻȣԭ, ڲԣ
            
            usb_OUT_done();
        }
        
		 while((curtime - pretime) <= 1000){
            OLED_ShowImage(image,128,64);
            curtime = tick;
            count++;
        }
        OLED_ShowString(0,0,"time:           ");        
        OLED_ShowNum(48,0,curtime-pretime);
        
#ifdef HARDWARE_I2C
        
        OLED_ShowString(0,6,"HARD FPS:       ");
        OLED_ShowNum(80,6,count);
        LED0 = ~LED0;
#else
        OLED_ShowString(0,6,"SOFT FPS:       ");
        OLED_ShowNum(80,6,count);
        LED1 = ~LED1;
#endif
        count = 0;
        delayms(5000);
        
        curtime = tick;
        pretime = curtime;

	}
}

void Timer0_Isr(void) interrupt 1
{
    tick++;    
}